# go-utils
A set of utilities used by our Golang projects
* [errors](./errors/README.md)

## Creating a new tag
When making changes, a new tag needs to be made in order to use the updated library in your project. First pull the tags, and check the latest version.

`git pull --tags`

`git tag`

The output will be a list of tags. Create a new tag with the version number increased. E.g. if the last tag was `v1.2.7`, the new tag could be `v1.2.8`. Then push the tag.

`git tag -a v1.2.8 -m "Tag v1.2.8"`

`git push --tags`

For your project, upgrade to the new version by running the `go get` command.

`go get gitlab.com/uafrica/go-utils@v1.2.8`